#include<bits/stdc++.h>
using namespace std;
int main()
{
    int n,k;
    cin >> n >> k;
    int pom[n];
    int rez[n];
    for(int i=0;i<n;i++)
    {
        cin >> pom[i];
    }
    int a[n] = {0};int c=0;
    int a1[n] = {0};
    for(int i=0;i<n;i++)
    {
        int x = pom[i];
        if(x>=0)
        {
            a[x]++;
                if(a[x]==k)
                {
                    rez[c]=x;
                    c++;
                    a[x]=-1000000;
                }
        }
        else
        {
            a1[-x]++;
             if(a1[-x]==k)
                {
                    rez[c]=x;
                    c++;
                    a[-x]=-1000000;
                }
        }
    }
    cout << c << endl;
    for(int i=0;i<c;i++)
    {
        cout << rez[i] <<" ";
    }
}